#ifndef _WINC_BUFFER
#define _WINC_BUFFER

namespace WXP {
   class Buffer {
      int size;
      int max;
      int ind;
      unsigned char *data;     /**< Values array */
   
      public:
      int initClass();
      int init( int rsize );
      Buffer();
      Buffer(int rsize);
      ~Buffer();
      Buffer( const Buffer &data );
      Buffer operator=( const Buffer &data );
      int copy( const Buffer &data );
      int clear();
      int resize( int rsize );
      int check( int rsize );
      int add( unsigned char *dat, int rsize );
      int insert( int loc, unsigned char *dat, int rsize );
      /** Return data starting at pointer */
      inline const unsigned char *get(){ return data+ind; };
      unsigned char get( int ind );
      int read( unsigned char *dat, int rsize );
      int read( Buffer &buf );
      int read( Buffer &buf, int rsize );
      int readLine( unsigned char *dat, int rsize );
      int skipLine();
      int clearUsed();
      int seek( int num );
      int inc( int num );
      int trunc( int num );
      int equal( int off, const char *str );
      /** Return the pointer index */
      inline int getInd() { return ind; };
      /** Return the buffer size */
      inline int getSize() { return size; };
      /** Return the number of bytes available in buffer */
      inline int getAvail() { return size-ind; };
      /** Return the maximum size of buffer */
      inline int getMax() { return max; };
      int print();
      int dump( int off, int num );
      /** Prints number of bytes from start of buffer */
      inline int dump( int num ){ return dump( 0, num ); };
      /** Prints entire buffer */
      inline int dump(){ return dump( 0, size ); };

      friend class File;
      friend class Zlib;
      friend class BZlib;
   };
}
#endif
