#ifndef _WINC_CITYPLOT
#define _WINC_CITYPLOT

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/String.h>

namespace WXP {
   class CityPlot : public Drawing, public Listener {
      int marker;
      int fill;
      int output;
      int nzero;
      int sync;
      String filename;
      
      public:
      CityPlot();
      int init();
      int setParam( const char *str );
      
      int setFile();
      int setInput( const char *type );
      int setNameConv( const char *name );
      int setFilename();
      int setFilename( const char *file );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      /** Sets forecast time (ignored) */
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getDomain( Domain &domain );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      inline int getSync(){ return sync; };
      int draw( Plot &plot );
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}

#endif
