#ifndef _WINC_COLORFILL
#define _WINC_COLORFILL

#include <WXP/ColorMap.h>
#include <WXP/PlotAttr.h>

namespace WXP {
   class ColorFill {
      PlotAttr *attr;
      float *value;
      char label[20];
      
      float base;
      float intrvl;
      int num;
      int max;
      
      int initClass();

      public:
      ColorFill( ColorMap &color, const char *str );
      ColorFill( const ColorFill &fill );
      ColorFill( );
      ~ColorFill();
      ColorFill operator=( const ColorFill &fill );
      int init();
      int set( const ColorFill &fill );
      int set( ColorMap &color, const char *str );
      /** Returns true if fill attributes set */
      inline bool isSet(){ return num > 0 ? true : false; };
      int setFill( ColorMap &color, const char *str );
      int readFile( ColorMap &color, const char *file );
      int validateValues();
      int decode( ColorMap &color, const char *str );
      int setValues( float *vals, int num );
      bool areValuesSet();
      int getNum();
      float getBaseVal();
      float getValue( int ind );
      int setBase( float rbase );
      /** Returns base value */
      inline float getBase(){ return base; };
      int setInterval( float rintrvl );
      /** Returns interval */
      inline float getInterval(){ return intrvl; };
      int getInd( float rvalue );
      PlotAttr get( float rvalue );
      PlotAttr get( int ind );
      const char *getColorName( int ind );
      int getColor( int ind );
      int getColor( float rvalue );
      /** Returns fill label for annotation */
      inline const char *getLabel(){ return label; };
      int print();

   };
}

#endif
