#ifndef _WINC_DATAMATH
#define _WINC_DATAMATH
   
#include <WXP/Data.h>

namespace WXP {
   class DataMath {
      public:
      static int units( Data &data, int fld, const char *units );
      static int units( Data &data, const char *units );
      static int uniqueId( Data &odata, Data &idata );
      static int removeMiss( Data &odata, Data &idata );

      static int max( Data &odata, Data &dataa, int flda, Data &datab, int fldb );
      static int max( Data &odata, Data &dataa, Data &datab );
      static int max( Data &odata, Data &idata, int ifld );
      static int max( Data &odata, Data &idata );

      static int min( Data &odata, Data &dataa, int flda, Data &datab, int fldb );
      static int min( Data &odata, Data &dataa, Data &datab );
      static int min( Data &odata, Data &idata, int ifld );
      static int min( Data &odata, Data &idata );

      static int add( Data &odata, Data &dataa, int flda, Data &datab, int fldb );
      static int add( Data &odata, Data &dataa, Data &datab );
      static int add( Data &odata, Data &idata, int ifld );
      static int add( Data &odata, Data &idata );

      static int diff( Data &odata, Data &dataa, int flda, Data &datab, int fldb );
      static int diff( Data &odata, Data &dataa, Data &datab );

      static int replace( Data &data, int fld, float old, float val );
      static int replace( Data &data, float old, float val );

      static int offset( Data &data, int fld, float offset );
      static int offset( Data &data, float offset );

      static int scale( Data &data, int fld, float scale );
      static int scale( Data &data, float scale );

      static int removeValid( Data &odata, Data &data, int min );
      static int average( Data &odata, Data &data );

      static int cutoff( Data &odata, const char *cmd, float cutoff, float nval, Data &idata, int fld  );
   };
}   
#endif
