#ifndef _WINC_DATETOOL
#define _WINC_DATETOOL

#include <WXP/Date.h>
#include <WXP/ForeTime.h>
#include <WXP/String.h>
#include <WXP/Timezone.h>

namespace WXP {
   class DateTool {
      static const char *months[12];
      static const char *months_lc[12];
      static const char *day_of_week[7];
      public:
      static int getSeconds( const char *str );
      static int getMinutes( const char *str );
      static int getCurrent( String &str );
      static int getCurrent( const char *encode, String &str );
      static int decode( const char *str, Date &date );
      static int decodeMonth( const char *str );
      static const char *getMonthLower( int month );
      static const char *getMonth( int month );
      static const char *getMonthLong( int month );
      static const char *getDayWeek( int day );
      static int createLabel( const char *prefix, Date &date, Timezone &tz, int flag, String &str );
      static int createLabel( const char *prefix, Date &date, Timezone &tz, String &str );
      static int createLabel( Date &date, Timezone &tz, String &str );
      static int createLabel( Date &date, String &str );
      static int createLabel( Date &date, Timezone &tz, float hour, String &str );
      static int createLabel( Date &date, Timezone &tz, const char *name, ForeTime &ftime, String &str );
      static int createLabel( Date &date, Timezone &tz, const char *name, float hour, String &str );
      static int createLabel( Date &date, const char *name, float hour, String &str );
      static int createHourLabel( float hour, int flag, String &str );
      static int print( int secs );

      static const int NONE = 0x0;  /**< Null Flag */
      static const int DAY_OF_WEEK = 0x1;  /**< Flag to add day of week to label */
   };
}
#endif
