#ifndef _WINC_DATEVAL
#define _WINC_DATEVAL

namespace WXP {
   struct DateVal {
      int year;     /**< Year */
      int month;    /**< Month 1-12 */
      int day;      /**< Day of month 1-31 */
      int hour;     /**< Hour of day GMT 0-23 */
      int min;      /**< Minute */
      float sec;    /**< Second */
   
      static int num_day[13];   /**< Number of days in each month (nonleap) */
      static int num_day_leap[13];  /**< Number of days in each month (leap) */
   
      int init();
      DateVal();
      int validate();
      long computeSecs();
      int set( int ryear, int rmonth, int rday, int rhour, int rmin, float rsec );
      /** Sets the year */
      inline int setYear( int val ){ year = val; return 1; };
      /** Gets the year */
      inline int getYear(){ return year; };
      /** Sets the month */
      inline int setMonth( int val ){ month = val; return 1; };
      /** Gets the month */
      inline int getMonth(){ return month; };
      /** Sets the day */
      inline int setDay( int val ){ day = val; return 1; };
      /** Gets the day */
      inline int getDay(){ return day; };
      /** Sets the hour */
      inline int setHour( int val ){ hour = val; return 1; };
      /** Gets the hour */
      inline int getHour(){ return hour; };
      /** Sets the minute */
      inline int setMinute( int val ){ min = val; return 1; };
      /** Gets the minute */
      inline int getMinute(){ return min; };
      /** Sets the second */
      inline int setSecond( float val ){ sec = val; return 1; };
      /** Gets the second */
      inline float getSecond(){ return sec; };
      int print();
   };
}
#endif

