#ifndef _WINC_DATUMPLOT
#define _WINC_DATUMPLOT

#include <WXP/ColorFill.h>
#include <WXP/Datum.h>
#include <WXP/DatumAttr.h>
#include <WXP/EarthPoint.h>
#include <WXP/Plot.h>
#include <WXP/PlotAttr.h>
#include <WXP/Point.h>

namespace WXP {
   class DatumPlot {
      String color_table;
      String color_fill;
      char format[10];
      int def_type;
      DatumAttr attr;
      int use_fill;
      ColorFill fill;
      float base;
      float intrvl;
      Point ppt;
      float scale;
      int post_line;
      int first;

      public:
      DatumPlot();
      int init();
      int setParam( const char *str );
      int setType( const char *str );
      int setColorTable( const char *str );
      int setColorFill( const char *str );
      int setInterval( float val );
      int setBase( float val );
      int setAttr( const char *str );
      int setAttr( PlotAttr &pattr );
      int setColor( const char *str );
      int setFormat( const char *str );
      /** Sets the scale factor of plots */
      inline int setScale( float val ){ scale = val; return 1; };
      int setMarker( int type );
      int draw( Plot &plot, Datum &data );
      int draw( Plot &plot, float rlat, float rlon, int type, 
	    const char *data, const char *format );
      int draw( Plot &plot, EarthPoint &ept, int type, 
	    const char *data, const char *format );
      int draw( Plot &plot, float rlat, float rlon, int type, 
	    float value, const char *format );
      int draw( Plot &plot, EarthPoint &ept, int type, 
	    float value, const char *format );
      int print();
   };
}
#endif
