#ifndef _WINC_EARTHPOINT
#define _WINC_EARTHPOINT

namespace WXP {
   struct EarthPoint {                /* Coordinate data structure */
      float lat;     /**< Latitude */
      float lon;     /**< Longitude */
      float elev;    /**< Elevation */
   
      int init();
      EarthPoint();
      EarthPoint( float rlat, float rlon );
      EarthPoint( float rlat, float rlon, float relev );
      int set( float rlat, float rlon );
      int set( float rlat, float rlon, float relev );
      /** Sets the elevation */
      inline int setElev( float relev ){ elev = relev; return 1; };
      /** Sets object from another EarthPoint object */
      inline int set( EarthPoint ept ){ *this = ept; return 1; };
      /** Gets the latitude */
      inline float getLat(){ return lat; };
      /** Gets the longitude */
      inline float getLon(){ return lon; };
      /** Gets the elevation */
      inline float getElev(){ return elev; };
      int print();
   };
}
#endif
