#ifndef _WINC_FIGURE
#define _WINC_FIGURE

#include <time.h>

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/PlotItem.h>
#include <WXP/Rect.h>
#include <WXP/String.h>

namespace WXP {
   
   class Figure : public Listener {
      Plot plot;
      PlotItem *plot_queue;
      String file;
      String ftime;
      Date bdate;
      Date ldate;
      Domain bdomain;
      int loop_frames;
      int num_frames;   // Number of frames in loop
      int num_plot;     // Number of plots in frame
      int loop_type;    // Type of loop based on time or file
      int loop_inc;     // The increment in time for each plot
      int redraw;
      int border;
      int num_redraw;
      int refresh;
      time_t rtime;
     
      public:
      Figure();
      Figure( const char *param );
      ~Figure();

      int init();
      int setParam( const char *param );
      int open( const char *param );
      int open();
      int close();
      int setForeTime( const char *fore );
      int setDomain( Domain &rdomain );
      int setLoopType( int rtype );
      /** Sets whether Figure should automatically refresh plot */
      inline int setRefresh( int val ){ refresh = val; return 1; };
      int setDate( Date &date );
      int setDate( Date &date, int inc, int num );
      int draw( );
      int startPlot();
      int startPlot( Domain &rdomain );
      int startPlot( Rect &offset, float aspect );
      int startPlot( Rect &offset, Domain &rdomain );
      int startPlot( Rect &offset );
      int clearQueue( );
      int addDrawing( Drawing &draw );
      int draw( Drawing &draw );
      int drawFrame( Date &date );
      int drawFrame( const char *fore );
      int endPlot();
      int drawPlot();
      int updateLoop( Date &date );
      int manage();
      int setDrawing( const char *str );
      bool isDrawing( int ind );
      void callback( const char *ev_str, const char *ev_data, const void *data );
   
   };
}
#endif
