#ifndef _WINC_FRONTDATA
#define _WINC_FRONTDATA

#include <WXP/Date.h>
#include <WXP/EarthPoint.h>
#include <WXP/EarthPoints.h>

namespace WXP {
   class FrontData {
      Date date;     
      EarthPoints epts;
      int fore;
      int type;
      float pres;
   
      public:
      FrontData();
      inline int getDate( Date &rdate ){ rdate = date; return 1; };
      inline int getSeconds(){ return date.getSeconds(); };
      inline int setType( int rtype ){ type = rtype; return 1; };
      inline int getType(){ return type; };
      inline int setFore( int rfore ){ fore = rfore; return 1; };
      inline int getFore(){ return fore; };
      inline int setPres( float rpres ){ pres = rpres; return 1; };
      inline float getPres(){ return pres; };
      int addPoint( float lat, float lon );
      int getPoint( int ind, EarthPoint &ept );
      float getLat( int ind );
      float getLon( int ind );
      inline int getNum(){ return epts.getNum(); };
      int init();
      int print();

      enum Type {
	 LOW,
	 HIGH,
	 HURRICANE,
	 TROP_STORM,
	 COLD,
	 WARM,
	 OCCLUDED,
	 STATIONARY,
	 TROF,
	 MISC
      };

      friend class FrontFile;

   };
}   
#endif
