#ifndef _WINC_GRIDBOX
#define _WINC_GRIDBOX

#include <WXP/Domain.h>
#include <WXP/Grid.h>
#include <WXP/Point.h>

namespace WXP {
   class GridBox {
      float val[4];
      float level;
      int proj;
      int span;  // Does box span the sides of the domain
      Point pt[4];
      Point cpt[4];
      float side[4];
      int numside;
      int cross[4]; 
      float tsides;
      float min, max;
      float tweak;
      int equal;
      int setCrossPoint( int ind, Point &opt );
      
      public:
      GridBox();
      int init();
      int set( Grid &grid, Domain &domain, int x, int y );
      int set( Grid &grid, Domain &domain, int x, int y, float level );
      int initLevel();
      int setLevel( float level );
      inline int setTweak( float t ){ tweak = t; return 1; };
      inline float getLevel(){ return level; };
      inline float getMin(){ return min; };
      inline float getMax(){ return max; };
      inline float getTotalDsides(){ return tsides; };
      inline int getCross( int rside ){ 
	 return rside < 0 || rside > 3 ? -1: cross[rside]; };
      float getVal( int rside );
      float getSide( int rside );
      int setCross( int ind, int val );
      Point getCrossPoint( int rside );
      inline Point getCrossPoint1( int rside ){ return cpt[rside]; };
      Point getPoint( int corner );
      inline Point getPoint1( int corner ){ return pt[corner]; };
      inline int setNumSide( int val ){ numside = val; return 1; };
      inline int getNumSide(){ return numside; };
      inline int getEqual(){ return equal; };
      inline int getSpan(){ return span; };
      bool isDataValid();
      bool isLocateValid();
      int printVals();
      int printStats();
      int print();
      
      static const int TOP    = 0;
      static const int RIGHT  = 1;
      static const int BOTTOM = 2;
      static const int LEFT   = 3;
   
      static const int UL  = 0;
      static const int UR  = 1;
      static const int LL  = 2;
      static const int LR  = 3;
   };
}
#endif
