#ifndef _WINC_GRIDCONT
#define _WINC_GRIDCONT

#include <WXP/ContPlot.h>
#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/Grid.h>
#include <WXP/GridRead.h>
#include <WXP/Listener.h>
#include <WXP/ModelSpec.h>
#include <WXP/Plot.h>
#include <WXP/String.h>

namespace WXP {
   class GridCont : public Drawing, public Listener {
      char model[20];
      int label;
      int map;
      int map_fill;
      ModelSpec model_spec;
      Filename filename;
      ContPlot cont;
      GridRead gread;
      Grid grid;
      String grid_spec;
      int sync;
   
      public:
      GridCont();
      GridCont( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *str ); 
      int setFile( );
      int setInput( const char *type ); 
      int setNameConv( const char *name ); 
      int setFilename( ); 
      int setFilename( const char *str );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      int setModel( const char *str );
      inline int setLabel( int val ){ label = val; return 1; };
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int setColorTable( const char *str );
      int setColorFill( const char *str );
      inline int setType( int type ){ return cont.setType( type ); };
      inline int setBase( float val ){ return cont.setBase( val ); };
      inline int setInterval( float val ){ return cont.setInterval( val ); };
      inline int setLabelParam( int skip, int rad ){ return cont.setLabelParam( skip, rad ); };
      inline int setMap( bool val ){ map = val; return 1; };
      inline int setMapFill( int val ){ map_fill = val; return 1; };
      inline bool isTypeFill(){ return cont.isTypeFill(); };
      int getDomain( Domain &domain );
      inline int getSync(){ return sync; };
      int draw( Plot &plot, Grid &grid );
      int draw( Plot &plot );
      int print();
   };
}   
#endif
