#ifndef _WINC_HURADV
#define _WINC_HURADV

#include <WXP/Date.h>

namespace WXP {
   struct HurAdv {
      char wmo[20];
      int locate;
      char name[20];
      char num[10];
      Date date;
      float lat, lon;
      float wind;
      float pres;
      int level;
      int type;

      enum Loc {
	 NONE,
	 ATL,
	 EPAC,
	 CPAC,
	 WPAC,
	 SPAC,
	 NIND,
	 SIND
      };

      enum StormLevel {
	 WAVE,
	 DEPRESS,
	 STORM,
	 STORM1,
	 STORM2,
	 STORM3,
	 STORM4,
	 STORM4S,
	 STORM5 
      };

      enum StormType {
	 TROP,
	 SUBTROP,
	 EXTRATROP
      };

      HurAdv();
      int init();
      int print();
      int printTable();

      static int getLevel( float spd );
      static const char *getLoc( int locate );
      static const char *getLocAbbr( int locate );
      static const char *getTypeAbbr( int type );
      static const char *getLevelAbbr( int type );
      static const char*getLabel( int locate, int type, int level );
   };

}
#endif
