#ifndef _WINC_HURSTORM
#define _WINC_HURSTORM

#include <WXP/HurAdv.h>
#include <WXP/HurFore.h>

namespace WXP {
   struct HurStorm {
      char name[20];
      int locate;
      int type;    // Overall storm type
      int level;   // Overall storm level
      HurAdv adv[200];
      int nadv;
      HurAdv fore[10];
      int nfore;
      char disc_file[120];
      int disc_beg;
      int disc_end;
      char fore_file[120];
      int fore_beg;
      int fore_end;

      int init();
      inline const char* getName(){ return name; };
      inline int setLoc(int val){ locate = val; return 1; };
      inline const char* getLoc(){ return HurAdv::getLoc(locate); };
      inline int getYear(){ return adv[0].date.getYear(); };
      int update( HurFore &rfore );
      int sort();
      int readData( const char *file );
      int saveData( const char *file );
      int print();
      int printTable();
   };
}
#endif
