#ifndef _WINC_HURRICANE
#define _WINC_HURRICANE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Filename.h>
#include <WXP/HurAdv.h>
#include <WXP/HurFore.h>

namespace WXP {
   class Hurricane {
      File ifile;
      Date date;
      int header;
      char wmo[20];
      int locate;

      public:
      Hurricane();
      int init();
      int open( const char *file );
      int open( Filename &file );
      inline int setDate( Date &rdate ){ date = rdate; return 1; };
      int parse( HurFore &fore );
      int getStorm();
      int nextWord( char *str );
      int nextNumber( char *str );
      int parseAdvisory( HurAdv &adv );
      int parseForecast( HurFore &fore );
      int parseDiscussion( HurFore &fore );
      int parseWarning( HurFore &fore );
      int cleanNum( char *str );
      int getOff( char *str );

   };
}
#endif
