#ifndef _WINC_IMAGEFILE
#define _WINC_IMAGEFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/GifFile.h>
#include <WXP/Image.h>
#include <WXP/ImgWxpFile.h>
#include <WXP/PngFile.h>
#include <WXP/TiffFile.h>

namespace WXP {
   class ImageFile {
      int type;
      int access;
      File file;
      GifFile gif;
      PngFile png;
      TiffFile tiff;
      ImgWxpFile img;
      Date date;
      bool opened;
   
      public:
      /** Type of image file */
      enum Type {
         UNK,	/**< Unknown type */
         IMG,	/**< Uncompressed WXP image */
         IMGZ,	/**< Compressed WXP image */
         TIFF,	/**< TIFF image */
         GIF,	/**< GIF image */
         PNG	/**< PNG image */
      };
   
      ImageFile();
      int setVer( int v );
      int open( const char *filename, int raccess, int rtype );
      int open( const char *filename, int raccess, const char *rtype );
      int open( const char *filename, int raccess );
      int open( const char *filename );
      /** Returns if file is open or not */
      inline bool isOpen() {return opened;};
      int close();
      int getType( const char *str );
      int read( Image &image );
      int read( const char *filename, Image &image );
      int write( Image &image );
      int write( const char *filename, int rtype, Image &image );
      int write( const char *filename, Image &image );
   
      static int checkType( const char *filename );
      static int checkFilename( const char *filename );
   };
}   
#endif
