#ifndef _WINC_IMAGEMATH
#define _WINC_IMAGEMATH
   
#include <WXP/ColorMap.h>
#include <WXP/EarthRange.h>
#include <WXP/Grid.h>
#include <WXP/Image.h>

namespace WXP {
   class ImageMath {
      public:
      static int clip( Image &image, GeomBox &box, Image &new_image );
      static int clip( Image &image, EarthRange &range, Image &new_image );
      static int clip( Image &image, EarthPoint &ept, int width, int height, Image &new_image );
      static int scale( Image &image, float scale, Image &new_image );
      static int remap( Image &image, Domain &domain, Image &new_image );
      static int toIndex( Image &image, int rdepth, Image &new_image );
      static int toIndex( Image &image, Image &new_image );
      static int toIndex( Image &image, ColorMap &cmap, Image &new_image );
      static int toGray( Image &image, Image &new_image );
      static int toTrueColor( Image &image, int rdepth, Image &new_image );
      static int toTrueColor( Image &image, Image &new_image );
      static int compressColor( Image &image );
      static int merge( Image &oimg, Image &img );
      static int blank( Image &img, EarthPoint &ept1, EarthPoint &ept2 );
      static int blank( Image &img, float angle );
      static int maskLesser( Image &oimg, Image &img, Grid &grid );
      static int maskGreater( Image &oimg, Image &img, Grid &grid );
   };
}   
#endif
