#ifndef _WINC_IMAGEPLOT
#define _WINC_IMAGEPLOT

#include <WXP/ColorBar.h>
#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/Image.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/String.h>
#include <WXP/Timezone.h>

namespace WXP {
   class ImagePlot : public Drawing, public Listener {
      int map;
      int over;
      int fill;
      float zoom;
      String color_table;
      String color_fill;
      int tran_sat;
      int remap_inc;
      int pix_off;
      int pix_ave;
      char cutoff[20];
      float min_lon, max_lon;
      Filename filename;
      Timezone tz;
      Image image;
      int bar;
      int sync;

      public:
      ImagePlot();
      ImagePlot( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *type );
      int setNameConv( const char *type );
      int setFilename();
      int setFilename( const char *file );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getNumFrames();
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getDomain( Domain &domain );
      int setColorTable( const char *str );
      int setColorFill( const char *str );
      inline int setMap( bool val ){ map = val; return 1; };
      inline int getSync(){ return sync; };
      int drawImage( Plot &plot, Image &rimage );
      int draw( Plot &plot ); 
      int draw( Plot &plot, const char *filename ); 
      int draw( Plot &plot, Image &rimage );
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
