#ifndef _WINC_INTARRAY
#define _WINC_INTARRAY

#include <WXP/Const.h>

namespace WXP {
   class IntArray {                /* Coordinate data structure */
      int num;
      int max;
      int ind;
      int *vals;     /**< Values array */
   
      public:
      int init();
      int init( int size );
      IntArray();
      IntArray(int size);
      ~IntArray();
      IntArray( const IntArray &data );
      IntArray operator=( const IntArray &data );
      int copy( const IntArray &data );
      /** Clears the contents of the array */
      inline int clear(){ num = 0; return 1; };
      int expand( int size );
      int add( int rval );
      /** Adds a value (no bounds check) */
      inline int add1( int rval ){ 
	 vals[num] = rval; num++; return 1; };
      int set( int ind, int rval );
      int get( int ind, int &rval );
      int get( int ind );
      /** Return the number of points */
      inline int getNum() { return num; };
      int offset( int ind, int rval );
      int print();
   };
}
#endif
