#ifndef _WINC_KAVRADFILE
#define _WINC_KAVRADFILE

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/File.h>
#include <WXP/Image.h>
#include <WXP/KavradPacket.h>

namespace WXP {
   class KavradFile {
      File file;
      bool opened;
      
      char label[40];     /* Date time label */
      Date date;          /* Date time information */
      int height, width;
      Domain domain;      /* The domain of the image */
      int type;
      int start, end;
      int value;
      
      public:

      KavradFile();
      int open( const char *name );
      bool isOpen();
      int rewind();
      int close();
      int readHeader();
      int readPacket( KavradPacket &packet );
      int read( Image &image );
   };
   
}
#endif
