#ifndef _WINC_KMLDATA
#define _WINC_KMLDATA

#include <WXP/EarthPoints.h>
#include <WXP/StrLib.h>

namespace WXP {
   struct KmlData {
      int type;      /**< The number of points in each segment */
      char name[100];/**< The minimum latitude in segment */
      EarthPoints epts;

      KmlData();
      int init();
      int print();
      int printData();

      /** Get the type of object */
      inline int getType(){ return type; };
      inline int setType( int rtype ){ type = rtype; return 1; };
      /** Get the name associated with the object */
      inline const char *getName(){ return name; };
      inline int setName( const char *rname ){ StrLib::copy( name, 100, rname ); return 1; };
      inline int clearPoints(){ return epts.clear(); };
      inline int addPoint( EarthPoint &ept ){ return epts.add( ept ); };
      inline int getNum(){ return epts.getNum(); };
      inline EarthPoint getPoint( int ind ){ return epts.get( ind ); };
      inline EarthRange getRange(){ return epts.getRange(); };

      enum Type {
	 UNK,
	 LINE,
	 PLACE
      };

      friend class KmlFile;
   };
}
#endif

