#ifndef _WINC_KMLFILE
#define _WINC_KMLFILE

#include <libxml/encoding.h>

#include <WXP/Date.h>
#include <WXP/KmlData.h>

namespace WXP {
   class KmlFile {
      xmlDocPtr reader;
      xmlNodePtr node[10];
      int nlevel;
      char name[100];
      int type;
      bool opened;
   
      public:
      KmlFile();
      KmlFile( const char *filename );
      KmlFile( const char *filename, int rtype );
      ~KmlFile();
      bool isOpen();
      int open( const char *filename );
      int open( const char *filename, int rtype );
      int close();
      int read( KmlData &data );

      enum {
	 UNK,
	 NORM,
	 COMPRESS
      };
   
      static int checkType( const char *filename );
   };
}   
#endif
