#ifndef _WINC_LIGHTDATA
#define _WINC_LIGHTDATA

#include <WXP/Date.h>
#include <WXP/DateVal.h>

namespace WXP {
   class LightData {
      Date   date;     /* date of strike                       */
      float  lat;      /* latitude of flash/stroke (x 1000)    */
      float  lon;      /* logitude of flash/stroke (x 1000)    */
      float  signal;   /* signal strength * 10 of flash/stroke */
      int    multi;    /* multiplicity of flash                */
   
      public:
      LightData();
      int init();
      int setDate( long secs );
      int setDate( DateVal &dv );
      int setFsec( float secs );

      /** Gets the date of strike */
      inline Date getDate(){ return date; };
      /** Gets the date of strike */
      inline DateVal getDateval(){ return date.get(); };
      /** Gets the seconds of strike */
      inline int getSeconds(){ return date.getSeconds(); };
      /** Gets the minute of strike */
      inline int getMinute(){ return date.getMinute(); };
      int setLat( float rlat );
      int setLon( float rlon );
      int setLoc( float rlat, float rlon );
      /** Gets the latitude of strike */
      inline float getLat(){ return lat; };
      /** Gets the longitude of strike */
      inline float getLon(){ return lon; };
      int setSignal( float sig );
      /** Gets the signal of strike */
      inline float getSignal(){ return signal; };
      int setMulti( int mul );
      /** Gets the multiplicity of strike */
      inline int getMulti(){ return multi; };
      int print();
   };
}   
#endif
