#ifndef _WINC_LIGHTPLOT
#define _WINC_LIGHTPLOT

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/Timezone.h>

namespace WXP {
   class LightPlot : public Drawing, public Listener {
      int type;
      Date ldate;
      Timezone tz;
      float scale;
      int mark;
      int length;  // Number of minutes to plot all frames
      int min;  // Number of minutes to plot each frame
      int var;
      int bar;
      bool map;
      int sync;
      Filename filename;
      String color_table;
      String color;
      String color_fill;

      public:
      LightPlot();
      LightPlot( const char *param);
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *str );
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setFilename();
      int setFilename( const char *name );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      int getDomain( Domain &domain );
      inline int getSync(){ return sync; };
      int setColorTable( const char *str );
      int setColor( const char *str );
      int setColorFill( const char *str );
      int setScale( float val );
      int setTimezone( const char *str );
      /** Sets whether object is to draw map or not */
      inline int setMap( bool val ){ map = val; return 1; };
      int draw( Plot &plot );
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
