#ifndef _WINC_LRITFILE
#define _WINC_LRITFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Image.h>

namespace WXP {
   /*
      Product description information
   */
   class LritFile { 
      File file;
      bool opened;
      Date date;
   
      int type;
      int len;
      int hdr_len;
      int bytes;
      // Product description
      int data_type;
      int bits_pixel;
      int ncol;
      int nrow;
      int nseg;
      int seg;
      int compress;
      // Projection data
      char pname[33];
      char info[100];
      int cfac, lfac;
      int coff, loff;
      int lseg;

      int xdir;
      int ydir;
   
      public:
      LritFile();
      LritFile( const char *filename );
      ~LritFile();
      int init();
      int open( const char *filename );
      int close();
      bool isOpen();
      int getHeader();
      int read( Image &image );
      int readHeader( Image &image );
      int readData( Image &image );
   
   };
}
#endif
