#ifndef _WINC_MAPFILE
#define _WINC_MAPFILE

#include <WXP/EarthPoint.h>
#include <WXP/File.h>
#include <WXP/KmlFile.h>
#include <WXP/MapFileHeader.h>
#include <WXP/ShapeFile.h>
#include <WXP/Swap.h>

namespace WXP {
   class MapFile {
      File file;
      KmlFile kml;
      KmlData kdata;
      ShapeFile shape;
      ShapeData sdata;
      int cnt;
      int num;
      int access;
      int type;
      bool opened;
      Swap swap;
      public:
      
      MapFile();
      MapFile( const char *filename );
      MapFile( const char *filenamem, int raccess, int rtype );
      ~MapFile();
      
      int checkType( const char *filename );
      int open( const char *filenamem, int raccess, int rtype );
      int open( const char *filename );
      bool isOpen();
      int rewind();
      int seek( int off );
      /** Returns byte offset in map file */
      inline int tell(){ return file.tell(); };
      int close();
      /** Returns true if map file binary */
      inline bool isBinary(){ return type == BINARY; };
      int readHeader( MapFileHeader &hdr );
      int skipData();
      int readData( EarthPoint &ept );
      int writeHeader( MapFileHeader &hdr );
      int writeData( EarthPoint &ept );
      int print();

      enum Type {
	 UNK,    /**< Unknown map type */
	 BINARY, /**< Binary map type */
	 ASCII,  /**< ASCII map type */
	 KML,    /**< KML map type */
	 SHAPE   /**< Shape File map type */
      };
   };
}   
#endif
