#ifndef _WINC_MAPPLOT
#define _WINC_MAPPLOT

#include <WXP/Date.h>
#include <WXP/Drawing.h>
#include <WXP/Plot.h>
#include <WXP/Points.h>
#include <WXP/String.h>

namespace WXP {
   class MapPlot : public Drawing {
      int def;
      int type;
      int in_region;
      int fill_cont;
      int fill;
      int fline;
      int map_in;
      int index;
      float la, lo;
      String color_table;
      String color;
      String color_latlon;
      String color_line;
      String filenames;
   
      int process( Plot &plot, const char *str, int flag );
      public:
      MapPlot();
      MapPlot( const char *param );
      ~MapPlot();
      int init();
      int getDomain (Domain &domain);
      int setMapFiles( const char *str );
      int setFile();
      int setInput( const char *str );
      int setNameConv( const char *name );
      int setFilename();
      int setFilename( const char *name );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      /** Sets forecast time (ignored) */
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      /** Sets whether map object is to plot as fill overlay */
      inline int setFillCont( bool v ){ fill_cont = v; return 1; };
      int setColorTable( const char *str );
      int setColor( const char *name );
      int setColorLatLon( const char *name );
      int setColorLine( const char *str );
      int setParam( const char *str );
      /** Returns whether object is time sync (unused) */
      inline int getSync(){ return 0; };
      int drawSegment( Plot &plot, Points &pts );
      int draw( Plot &plot, const char *file );
      int drawLatLon( Plot &plot, float dlat, float dlon );
      int draw( Plot &plot );
      int print();
   
      static const int UNDER   = 1;
      static const int OVER    = 2;
   };
}   
#endif
