#ifndef _WINC_MDRFILE
#define _WINC_MDRFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Filename.h>
#include <WXP/MdrData.h>
#include <WXP/MdrRawData.h>
#include <WXP/MdrWxpFile.h>

namespace WXP {
   class MdrFile {
      int type;
      int access;
      File file;
      Date date;
      Date pdate;
      MdrWxpFile wxp;
      bool opened;
   
      public:
      MdrFile();
      MdrFile( Filename &filename );
      MdrFile( const char *filename );
      ~MdrFile();
      int init();
      inline bool isOpen(){ return opened; };
      int open( const char *filename, int raccess, int rtype );
      int open( const char *filename );
      int open( Filename &filename, int raccess, int rtype );
      int open( Filename &filename );
      int rewind();
      int close();
      int setDate( Date &rdate );
      inline int getDate( Date &rdate ){ rdate = date; return 1; };
      int decode( MdrRawData &raw, MdrData &data );
      int read( Image &image );
      int read( MdrRawData &data );
      int read( MdrData &data );
      int write( Image &image );
      int write( MdrData &data );
      // MDR types
      enum Type {
         UNK,
         RAW,
         WXP,
	 NETCDF
      };
   };
}   
#endif
