#ifndef _WINC_MDRREGION
#define _WINC_MDRREGION

namespace WXP {
   struct MdrRegion {
      char config[10];      /* Configuration of echoes */
      struct {
	 int cover;         /* Area coverage */
	 char type[5];      /* Type of precipitation */
	 int intens;        /* Intensity of precipitation */
      } prec[3];
      int num_prec;
      char trend[4];        /* Trend of precip coverage */
      struct {              /* Location of precipitation */
	 int dir,rad;       /* Direction and radius of precip area */
      } loc[5];
      int num_loc;
      struct {              /* Movement of precipitation */
	 char type;         /* Type of movement: Area,Cell,Line */
	 int dir,spd;       /* Direction and speed */
      } move[3];
      int num_move;
      
      struct {              /* Cloud tops */
	 int hgt;           /* Height */
	 int dir,rad;       /* Location */
      } tops;
      char rem[20];         /* Remarks */

      MdrRegion();
      int init();
      int print();
   };
};
#endif
