#ifndef _WINC_METARFILE
#define _WINC_METARFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Filename.h>
#include <WXP/String.h>

namespace WXP {
   class MetarFile {
      int type;
      long pos;
      bool opened;
      File file;
      Date date;
      char header[80];
      char cline[80];
      int ctype;
   
      public:
      MetarFile( );
      MetarFile( Filename &filename );
      ~MetarFile( );
      int open( Filename &filename );
      int init();
      bool isOpen( );
      int rewind( );
      int close( );
      int checkType( char *filename );
      int getLine( String &str );
      char *getHeader();
   
      static const int UNK = 0;    /**< Unkown data */
      static const int METAR = 1;  /**< Hourly METAR data */
      static const int SPECI = 2;  /**< intermediate METAR specials */
   };
}   
#endif
