#ifndef _WINC_MODELSPEC
#define _WINC_MODELSPEC

#include <WXP/Const.h>

namespace WXP {
   class ModelSpec {
      char name[20];
      int num;
      int nx, ny;
      int itype;

      struct ModelType {
   	 int x,y;
   	 int type;
   	 char name[20];
      };
      ModelType spec[12];
   
      public:
      ModelSpec();
      ModelSpec(const char *model);
      int init();
      int set( const char *model );
      /** Returns if specification is valid */
      inline bool valid(){ return num > 0? true: false; };
      /** Returns the number of grids needed */
      inline int getNum(){ return num; };
      /** Gets the specification name */
      inline const char *getName(){ return name; };
      /** Gets the file name convention \param ind	Index for pieced grid */
      inline const char *getName( int ind ){ 
	 return ind >= 0 && ind < num ? spec[ind].name: NULL; };
      /** Gets the number of grids in X for piecing */
      inline int getNx(){ return nx; };
      /** Gets the number of grids in Y for piecing */
      inline int getNy(){ return ny; };
      /** Gets the X location of grid \param ind	Index for pieced grid */
      inline int getX( int ind ){ 
	 return ind >= 0 && ind < num ? spec[ind].x: Const::MISS; };
      /** Gets the Y location of grid \param ind	Index for pieced grid */
      inline int getY( int ind ){ 
	 return ind >= 0 && ind < num ? spec[ind].y: Const::MISS; };
      /** Gets the grid type \param ind	Index for pieced grid */
      inline int getType( int ind ){ 
	 return ind >= 0 && ind < num ? spec[ind].type: Const::MISS; };
      int print();
   };
}
#endif
