#ifndef _WINC_MOSPLOT
#define _WINC_MOSPLOT

#include <WXP/Date.h>
#include <WXP/DatumPlot.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/GridCont.h>
#include <WXP/GridVect.h>
#include <WXP/Listener.h>
#include <WXP/MosGrid.h>
#include <WXP/Plot.h>
#include <WXP/String.h>
#include <WXP/Timezone.h>

namespace WXP {
   class MosPlot : public Drawing, public Listener {
      Filename filename;
      String param_str;
      String color_table;
      String color;
      char model[20];
      String time;
      String variable;
      char plot_type[10];
      Timezone tz;
      Domain gdomain;
      MosGrid mosgrid;
      DatumPlot dplot;
      GridCont gplot;
      GridVect vplot; 
      int map_fill;
      bool map;
      int sync;
   
      public:
      MosPlot();
      MosPlot( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *str );
      int setModel( const char *str );
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setForeTime( const char *fore );
      int setFilename();
      int setFilename( Date &date );
      int setFilename( const char *str );
      int setFilename( Date &date, const char *param );
      int setColorTable( const char *str );
      int setColor( const char *str );
      int setVariable( const char *str );
      inline int setMap( bool val ){ map = val; return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      int getDomain( Domain &domain );
      inline int getSync(){ return sync; };
      int draw( Plot &plot ); 
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
