#ifndef _WINC_NIDSIMAGE
#define _WINC_NIDSIMAGE

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Filename.h>
#include <WXP/Grid.h>
#include <WXP/Image.h>
#include <WXP/NidsInfo.h>
#include <WXP/NidsData.h>

namespace WXP {
   class NidsImage { 
      int cradius;
      int ramp_cut;
      int ramp_len;
      float thres[200];
      int mix[200];
      int snow[200];
      int nthres;
      int clear_air;
      int interp;
      int type;
      int mode;
      int box;
   
      NidsInfo info;
      NidsData data;

      public:
      NidsImage();
      NidsImage( const char *str );
      int init();
      int setParam( const char *str );
      inline int setClutterRad( int crad ){ cradius = crad; return 1; };
      int setRamp( int cut, int len );
      inline int getRampCut(){ return ramp_cut; };
      inline int getRampLen(){ return ramp_len; };
      int setThres( const char *str );
      int setClearAirUse( int val );
      inline int getClearAirUse(){ return clear_air; };
      int getMode();
      int getIndex( float val );
      int setup( Image &image );
      int readSite( Filename &filename );
      int addSite( Image &image );
      int addSite( Filename &filename, Image &image );
      int setImage( Filename &filename, Image &image );
      int applyMask(Image &image, Grid &mask);
      int print();
      int printSite();

      enum Type { 
	 RADIAL, 
	 RASTOR 
      };
   };
}
#endif
