#ifndef _WINC_PARCELPARAMS
#define _WINC_PARCELPARAMS

#include <WXP/LclData.h>
#include <WXP/UpaData.h>
#include <WXP/UpaLevel.h>

namespace WXP {
   struct ParcelParams {
      int par_type;
      float par_thick;
      UpaLevel par_lev;
      float Satad;
      LclData lcl;
      UpaLevel lcl_lev;
      float cap;
      float lfc;
      UpaLevel lfc_lev;
      float el;
      UpaLevel el_lev;
      float mpl;
      UpaLevel mpl_lev;
      float Bel;
      float Bmpl;
      float Bplus;
      float Bminus;
      float li;
      float wmax;
      float max_t;
      enum { SFC, LAYER, MAXT, USER };

      ParcelParams();
      int init();
      int setType( int type );
      int setType( float thick );
      int setType( float p, float t, float td );
      int setType( const char *str );
      int set( UpaData &data );
      int calc( UpaData &data , UpaLevel &plev );
      int printParcel();
      int print();
      
   };
}
#endif

