#ifndef _WINC_PLOTATTR
#define _WINC_PLOTATTR

#include <WXP/Const.h>
#include <WXP/StrLib.h>

namespace WXP {
   class PlotAttr {
      float width;
      float height;
      float expan;
      int style;
      int shadow;
      int fill_pat;
      int color_ind;
      char color[20];
      char font[120];
   
      public:
      PlotAttr();
      PlotAttr( const char *str );
      PlotAttr( const char *str, const char *def );
      int set( const char *str );
      int set( const char *str, const char *def );
      int parse( const char *str );

      inline int setWidth( float val ){ width = val; return 1; };
      inline float getWidth(){ return width; };
      inline bool validWidth(){ return width != Const::MISS; };

      inline int setHeight( float val ){ height = val; return 1; };
      inline float getHeight(){ return height; };
      inline bool validHeight(){ return height != Const::MISS; };

      inline int setExpan( float val ){ expan = val; return 1; };
      inline float getExpan(){ return expan; };
      inline bool validExpan(){ return expan != Const::MISS; };

      inline int getStyle(){ return style; };
      inline bool validStyle(){ return style != Const::MISS; };

      inline int setShadow( int val ){ shadow = val; return 1; };
      inline int getShadow(){ return shadow; };
      inline bool validShadow(){ return shadow != Const::MISS; };

      inline int getFillPat(){ return fill_pat; };
      inline bool validFillPat(){ return fill_pat != Const::MISS; };

      inline int setColorInd( int val ){ color_ind = val; return 1; };
      inline int getColorInd(){ return color_ind; };
      inline bool validColorInd(){ return color_ind != Const::MISS; };

      int setColor( const char *str );
      inline const char *getColor(){ return color; };
      bool validColor();

      inline const char *getFont(){ return font; };
      inline bool validFont(){ return StrLib::valid( font ); };

      int update( PlotAttr &attr );

      int print();
      int init();
   
      static int parseFillStyle( const char *str );
      static int parseMarker( const char *str );
      static int update( PlotAttr &attr1, PlotAttr &attr2 );
   };
}   
#endif
