#ifndef _WINC_PRODUCT
#define _WINC_PRODUCT

#include <WXP/File.h>

namespace WXP {
   struct Product {
      char  pattern[40];       /**< Product number or WMO header */
      char  act_str[10];       /**< Action string from bulletin file */
      int   action;            /**< Action to perform to data */
      char  file_tmpl[250];    /**< Template used for file action */
      char  hfile_tmpl[100];   /**< Template used for header file action */
      char  command[250];      /**< Command/file used with action */
      int   raw;               /**< Specifies whether to save raw data */
      int   binary;            /**< Specifies whether product contains
					binary data */
      int   selected;          /**< Specifies whether selected */
      int   unique;            /**< Specifies single output */
      int   pan;               /**< Specifies whether to send PAN message */
      int   offset;            /**< Time offset in seconds */
      int   pos;               /**< Current position in file */
      File  file;              /**< Output data file */
      File  hfile;             /**< Header file */

      Product();
      int init();
      int print();

      /** Output action */
      enum Action { 
	 DEFAULT,    /**< Default action */
	 WRITE,      /**< Writes data to file */
	 APPEND,     /**< Appends data to file  */
	 PIPE,       /**< Pipes product to program */
	 FILE,       /**< Output to file */
	 RUN,        /**< Runs a program when data received */
	 NONE        /**< No output */
      };
   };
}
#endif
