#ifndef _WINC_PROFFILE
#define _WINC_PROFFILE

#include <WXP/BufrFile.h>
#include <WXP/NetCdfFile.h>
#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Filename.h>
#include <WXP/ProfData.h>

namespace WXP {
   /*
      Product description information
   */
   class ProfFile { 
      int type;
      bool opened;
      Date date;   // File date
      NetCdfFile cdf;
      BufrFile bufr;
      int num;
   
      float dh;  // distance between levels

      public:
      ProfFile();
      ProfFile( const char *filename );
      ProfFile( Filename &filename );
      ~ProfFile();
      int init();
      int checkType( const char *filename );
      int open( const char *filename );
      int open( Filename &filename );
      int close();
      bool isOpen();
      int setDate( Date &rdate );
      int read( ProfData &data );

      enum Type {
	 BUFR,
	 NETCDF
      };
   };
}
#endif

