#ifndef _WINC_RAWGRID
#define _WINC_RAWGRID

#include <WXP/Data.h>
#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Filename.h>
#include <WXP/Grids.h>
#include <WXP/ObjectAnal.h>
#include <WXP/String.h>

namespace WXP {
   class RawGrid {
      ObjectAnal oa;
      Filename filename;
      Domain domain;
      int grid_scale;
   
      public:
      RawGrid();
      RawGrid( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *str );
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setFilename();
      int setFilename( Date &date );
      int setFilename( const char *str );
      int setFilename( Date &date, const char *param );
      int setVariable( const char *str );
      int getDate( Date &date );
      int setDomain( Domain &rdomain );
      inline int setGridScale( int scale ){ grid_scale = scale; return 1; };
      int compute( Data &data, Grids &grid );
      int compute( Grids &grid );
      int print();
   };
}
#endif
