#ifndef _WINC_RCMFILE
#define _WINC_RCMFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Filename.h>
#include <WXP/RcmData.h>
#include <WXP/RcmRawData.h>
#include <WXP/RcmWxpFile.h>

namespace WXP {
   class RcmFile { 
      int type;
      int access;
      File file;
      Date date;
      RcmWxpFile wxp;
      bool opened;

      public:
      RcmFile();
      RcmFile( const char *filename );
      RcmFile( Filename &filename );
      ~RcmFile();
      int init();
      int open( const char *filename, int raccess, int rtype );
      int open( const char *filename );
      int open( Filename &filename, int raccess, int rtype );
      int open( Filename &filename );
      int close();
      inline bool isOpen(){ return opened; };
      int setDate( Date &rdate );
      inline int getDate( Date &rdate ){ rdate = date; return 1; };
      int decode( RcmRawData &raw, RcmData &data );
      int read( Image &image ); 
      int read( RcmRawData &data );
      int read( RcmData &data );
      int write( Image &image ); 
      int write( RcmData &data );

      // RCM types
      enum Type {
	 UNK,
	 RAW,
	 WXP,
	 NETCDF
      };
   };
}
#endif

