#ifndef _WINC_REDBOOKFILE
#define _WINC_REDBOOKFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/RedbookPacket.h>
#include <WXP/RedbookPlotParam.h>
#include <WXP/RedbookText.h>
#include <WXP/RedbookVector.h>

namespace WXP {
   class RedbookFile {
      File file;
      Date date;
      unsigned char data[10000];
      int len;
      int ind;
      int pi;
      bool opened;
   
      public:
      RedbookFile();
      RedbookFile( const char *file );
      ~RedbookFile( );
      int open( const char *file );
      int close();
      bool isOpen();
      int readHeader();
      int getPi();
      inline int getDate( Date &rdate ){ rdate = date; return 1; };
      int readPacket( RedbookPacket &pack );
      int procPacket( RedbookPacket &pack );
      int plotParam( RedbookPacket &pack, RedbookPlotParam &param );
      int vector( RedbookPacket &pack, RedbookVector &vect );
      int text( RedbookPacket &pack, RedbookText &text );
   };
}   
#endif
