#ifndef _WINC_REDBOOKPLOT
#define _WINC_REDBOOKPLOT

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/String.h>
#include <WXP/Timezone.h>

namespace WXP {
   class RedbookPlot : public Drawing, public Listener {
      Domain domain;
      String color_table;
      String color;
      Timezone tz;
      int fill;
      int proj;
      char type[20];
      int sync;
      int map;
      Filename filename;

      public:
      RedbookPlot();
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *file );
      int setNameConv( const char *file );
      int setHour( const char *str );
      int setFilename();
      int setFilename( const char *file );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      /** Sets the forecast time (ignored) */
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date);
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      int setDomain( const char *str );
      int setDomain( Domain &rdomain );
      int getDomain( Domain &rdomain );
      int setColorTable( const char *str );
      int setColor( const char *str );
      int setTimezone( const char *str );
      /** Sets whether object is to draw map or not */
      inline int setMap( bool val ){ map = val; return 1; };
      /** Returns whether object is a time sync */
      inline int getSync(){ return sync; };
      int draw( Plot &plot );
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
