#ifndef _WINC_RESRC
#define _WINC_RESRC

#include <WXP/String.h>

namespace WXP {
   class Resrc {
      struct ResrcItem {
   	 char *name;		/**< Name of resource */
   	 char *data;		/**< Resource data */
   	 int type;		/**< Flag */
   	 ResrcItem *next;	/**< Link to next resource */
      };

      ResrcItem *root;
      ResrcItem *cur;
      ResrcItem *last;
   
      public:
      Resrc( );
      ~Resrc( );
      int clear( );
      int init( );
      int add( const char *name, const char *data, int type );
      int set( const char *name, const char *data );
      int set( const char *name, const char *data, int type );
      int set( const char *name, String &data );
      int put( const char *name, const char *data );
      int prepend( const char *name, const char *data, char delim = '\n' );
      int append( const char *name, const char *data, char delim = '\n' );
      const char *get( const char *name );
      const char *get( const char *name, const char *def );
      int getType( const char *name );
      int getValues( String &name, String &value, int flag );
      bool getBool( const char *name );
      float get( const char *name, float val );
      int get( const char *name, int val );
      int scanf( const char *name, const char *form, ... );
      int rewind();
      const char *getNext();
      int print( const char *name );
      int printAll( );

      enum ResrcType {
	 NONE,     /**< No source */
	 BASE,     /**< Predefined */
	 FILE,     /**< Resource/defaults file */
	 ENV,      /**< Environment variables */
	 COMMAND,  /**< Command line */
	 USER      /**< Users specified */
      };
   };
}  
#endif
