#ifndef _WINC_SATPLOT
#define _WINC_SATPLOT

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/Image.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/String.h>
#include <WXP/Timezone.h>

namespace WXP {
   class SatPlot : public Drawing, public Listener {
      char label[20];
      int type;
      int over;
      int fill;
      int map;
      int bar;
      float zoom;
      String color_table;
      String color_fill;
      String model_mask;
      String calib;
      int tran_sat;
      int map_rem;
      int remap_inc;
      int pix_off;
      int pix_ave;
      char cutoff[20];
      float min_lon, max_lon;
      int datim;
      int sync;
      Timezone tz;
      Filename filename;
      String image_dom;
      String output;
      Image image;

      public:
      SatPlot();
      SatPlot( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile( );
      int setInput( const char *rtype );
      int setOutput( const char *str );
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setTimezone( const char *str );
      int setFilename( );
      int setFilename( const char *file );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getNumFrames();
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getDomain( Domain &domain );
      int setColorTable( const char *str );
      int setColorFill( const char *str );
      int setModelMask( const char *str );
      int setCalibration( const char *str );
      inline int setMap( bool val ){ map = val; return 1; };
      inline int getSync(){ return sync; };
      int maskModel( Image &image, Date &date );
      int saveImage( Image &image );
      int draw( Plot &plot, Image &bimage );
      int draw( Plot &plot ); 
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
