#ifndef _WINC_SFCFILE
#define _WINC_SFCFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/SfcCdfFile.h>
#include <WXP/SfcData.h>
#include <WXP/SfcWxpFile.h>
#include <WXP/SfcXmlFile.h>

namespace WXP {
   class SfcFile {
      int type;
      int ver;
      int access;
      SfcWxpFile wfile;
      SfcCdfFile cfile;
      SfcXmlFile xfile;
      File file;
      Date date;
      bool opened;
   
      public:
      SfcFile();
      SfcFile( const char *filename );
      SfcFile( const char *filename, int access, int type );
      ~SfcFile();
      bool isOpen();
      int open( const char *filename, int access, int type );
      int open( const char *filename, int access, const char *type );
      int open( const char *filename );
      int rewind();
      int close();
      int getDate( Date &rdate );
      const char *getDatim();
      int setDate( Date &rdate );
      int read( SfcData &data );
      int write( SfcData &data );
   
      static int checkType( const char *filename );
      static int getType( const char *type );
      // Surface types
      enum Type {
         UNK,
         WXP,
         NETCDF,
         XML,
         XMLC,
         UNISYS
      };
   };
}   
#endif
