#ifndef _WINC_SFCPLOT
#define _WINC_SFCPLOT

#include <WXP/Date.h>
#include <WXP/DatumPlot.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h>
#include <WXP/Filename.h>
#include <WXP/GridCont.h>
#include <WXP/GridVect.h>
#include <WXP/Listener.h>
#include <WXP/Plot.h>
#include <WXP/SfcGrid.h>
#include <WXP/String.h>
#include <WXP/Timezone.h>

namespace WXP {
   class SfcPlot : public Drawing, public Listener {
      Filename filename;
      String param_str;
      String variable;
      char plot_type[10];
      Timezone tz;
      Domain gdomain;
      SfcGrid sfcgrid;
      DatumPlot dplot;
      GridCont gplot;
      GridVect vplot;
      String output;
      bool map;
      int map_fill;
      int sync;
   
      public:
      SfcPlot();
      SfcPlot( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *str );
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setFilename();
      int setFilename( Date &date );
      int setFilename( const char *str );
      int setFilename( Date &date, const char *param );
      /** Sets the forecast time (ignored) */
      inline int setForeTime( const char *fore ){ return 1; };
      int setColorTable( const char *str );
      int setColor( const char *str );
      int setVariable( const char *str );
      int setPlotType( const char *str );
      int setTimezone( const char *str );
      int setGridDomain( const char *str );
      int setOutput( const char *file );
      /** Sets whether object is to draw map or not */
      inline int setMap( bool val ){ map = val; return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      int getDomain( Domain &domain );
      /** Returns whether object is a time sync */
      inline int getSync(){ return sync; };
      int draw( Plot &plot ); 
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
