#ifndef _WINC_SFCWXPFILE
#define _WINC_SFCWXPFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/SfcData.h>

namespace WXP {
   class SfcWxpFile {
      int type;
      int ver;
      int access;
      int cnt;
      int num;
      File file;
      Date date;
      char datim[30];
      bool opened;
   
      public:
      SfcWxpFile( );
      SfcWxpFile( const char *filename );
      SfcWxpFile( const char *filename, int access );
      ~SfcWxpFile( );
      bool isOpen();
      int open( const char *filename, int access );
      int rewind( );
      int close( );
      int setDate( Date &rdate );
      int getDate( Date &rdate );
      inline const char *getDatim(){ return datim; };
      int read( SfcData &data );
      int write( SfcData &data );
   
      static int checkType( const char *filename );
   };
}   
#endif
