#ifndef _WINC_SOUNDPARAMS
#define _WINC_SOUNDPARAMS

#include <WXP/CclData.h>
#include <WXP/LclData.h>
#include <WXP/ThetaEData.h>
#include <WXP/UpaData.h>
#include <WXP/UpaLevel.h>

namespace WXP {
   struct SoundParams {
      LclData lcl;     /* Surface LCL */
      UpaLevel lcl_lev;
      float frz;       /* Freezing level */
      UpaLevel frz_lev[5];
      float wb0;       /* Wet bulb zero */
      UpaLevel wb0_lev;
      float lapse57;   /* 700-500 mb lapse rate */
      float max_t;     /* Est maximum temp */
      float precip;    /* Precipitable water */
      float mean_rh;   /* Mean RH */
      float thick;     /* 1000-500 mb thickness */
      ThetaEData thetae; /* Theta E index */
      CclData ccl;     /* Convective Condensation Level */
      UpaLevel ccl_lev;
      float li;        /* Lifted Index */
      float li3;        /* Lifted Index */
      float li7;        /* Lifted Index */
      float cap;       /* Cap strength */
      float si;        /* Showalter Index */
      float tt;        /* Total Totals index */
      float ct;        /* Cross Totals index */
      float vt;        /* Vertical Totals index */
      float ki;        /* K index */
      float sweat;     /* Sweat index */
      float ei;        /* Energy index */

      SoundParams();
      int init();
      int set( UpaData &data );
      int print();
      
   };
}
#endif

