#ifndef _WINC_SOUNDPLOT
#define _WINC_SOUNDPLOT

#include <WXP/Date.h>
#include <WXP/Domain.h>
#include <WXP/Drawing.h> 
#include <WXP/Filename.h>
#include <WXP/Listener.h>
#include <WXP/ParcelParams.h>
#include <WXP/Plot.h>
#include <WXP/ThermPlot.h>
#include <WXP/UpaData.h>

namespace WXP {
   class SoundPlot : public Drawing, public Listener {
      int type;
      int draw_par;
      int refresh;
      char id[15];
      int diag;
      int sync;
      String color;
      String color_sound;
      Filename filename; 
      ThermPlot therm;
      ParcelParams parcel;

      public:
      SoundPlot();
      SoundPlot( const char *param );
      int init();
      int setType( int rtype );
      int setType( const char *str );
      int getType();
      inline int setDiag( int val ){ diag = val; return 1; };
      int setParam( const char *str );
      int setFile();
      int setInput( const char *type );
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setFilename();
      int setFilename( const char *name );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      inline int setForeTime( const char *fore ){ return 1; };
      int setId( const char *rid );
      int promptId();
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      int setLineColor( const char *str );
      int setSoundColor( const char *str );
      int getDomain( Domain &domain );
      inline int getSync(){ return sync; };
      int draw( Plot &plot );
      int draw( Plot &plot, UpaData &data );
      void callback( const char *ev_str, const char *ev_data, const void *data );
      int print();
   };
}
#endif
