#ifndef _WINC_STRLIB
#define _WINC_STRLIB

namespace WXP {
   class StrLib {
      public:
      static int clear( char *string );
      static int length( const char *string );
      static int replace( char *string, char tar, char fill );
      static int trimWS( char *string );
      static int stripWS( char *string );
      static int chop( char *string );
      static int lowCase( char *string );
      static int upCase( char *string );
      static int upCaseFirst( char *string );
      static int toInt( const char *str, int ind, int len );
      static int toInt( const char *str, int ind );
      static int toInt( const char *str );
      static float toFloat( const char *str, int ind, int len );
      static float toFloat( const char *str, int ind );
      static float toFloat( const char *str );
      static int subString( const char *s1, int ind, int len, char *s2, int len2 );
      static int splice( char *s1, int len1, int i1, int n, const char *s2 );
      static const char *getField( const char *str, char delim, int field );
      static int index( const char *s1, char s2 );
      static int index( const char *s1, char s2, int num );
      static int lastIndex( const char *s1, char s2 );
      static int occurs( const char *s1, char s2 );
      static bool equal( const char *s1, const char *s2 );
      static int icmp( const char *s1, const char *s2 );
      static bool iequal( const char *s1, const char *s2 );
      static bool contains( const char *s1, const char *s2 );
      static bool hasToken( const char *s1, char delim, const char *s2 );
      static int where( const char *s1, const char *s2 );
      static int icmp( const char *s1, const char *s2, int num );
      static bool iequal( const char *s1, const char *s2, int num );
      static bool equal( const char *s1, const char *s2, int num );
      static bool equal( const char *s1, int num, const char *s2 );
      static int copy( char *s1, int len1, const char s2 );
      static int copy( char *s1, int len1, const char *s2 );
      static int copy( char *s1, int len1, const char *s2, int num );
      static int bcopy( unsigned char *s1, int len1, const unsigned char *s2, int num );
      static int append( char *s1, int len1, const char *s2, int num );
      static int append( char *s1, int len1, const char *s2 );
      static char *acopy( const char *str );
      static char *acopy( const char *str, int num );
      static int printf( char *str, int maxlen, const char *fmt, ... );
      static int aprintf( char *str, int maxlen, const char *fmt, ... );
      static char setChar( char *str, int ind, char ch );
      static char getChar( const char *str, int ind );
      static bool isNum( const char *string );
      static bool isNum( const char *string, int len );
      static int getInt( const char *string );
      static float getFloat( const char *string );
      static int clean( char *line );
      static bool valid( const char *str );
      static const char *valid( const char *str, const char *def );
      static bool validData( const char *str );
      static bool isAlphaNum( const char *str );
      static bool check( const char *str, const char *pat );
      static bool match( const char *str, const char *pat );
   };
}
#endif
