#ifndef _WINC_UNIT
#define _WINC_UNIT

#include <WXP/String.h>
#include <WXP/UnitData.h>

namespace WXP {
   class Unit {
      UnitData cvs[10];  // Stored conversions
      int ncvs;

      public:
      Unit();
      int init();
      bool valid( const char *in, const char *out );
      float convert( float value, const char *in, const char *out );
      int readFile( const char *uin, const char *uout, UnitData &data );
   
      static int scale( const char *in, float rscale, const char *mstr, String &out );
      static int parse( const char *str, String &var, String &units );
      static int change( String &str, const char *units );
      static bool equal( const char *unit1, const char *unit2 );
      static int simplify( char *unit );
      static int simplify( String &unit );
   };
}
#endif
