#ifndef _WINC_UPARAW
#define _WINC_UPARAW

#include <WXP/CityHash.h>
#include <WXP/Date.h>
#include <WXP/Datum.h>
#include <WXP/Domain.h>
#include <WXP/Filename.h>
#include <WXP/Raw.h>
#include <WXP/String.h>
#include <WXP/UpaFile.h>
#include <WXP/UpaData.h>

namespace WXP {
   class UpaRaw {
      Filename filename;
      String variable;
      String var_file;
      String level;
      Domain domain;
      CityHash hash;
   
      public:
      UpaRaw();
      UpaRaw( const char *param );
      int init();
      int setParam( const char *str );
      int setPath( const char *path );
      int setFile();
      int setInput( const char *str ); 
      int setNameConv( const char *name );
      int setHour( const char *str );
      int setFilename();
      int setFilename( Date &date );
      int setFilename( const char *str );
      int setFilename( Date &date, const char *param );
      int setVariable( const char *str );
      int setLevel( const char *str );
      int getDate( Date &date );
      int setDomain( Domain &rdomain );
      int setVarFile( const char *file );
      inline int getDomain( Domain &rdomain ){ rdomain = domain; return 1; };
      int createHash();
      int getInfo( UpaData &upadata, Datum &datum );
      int compute( Raw &data );
      int print();

      static int updateSpec( VarSpec &vs, Level &l );
   };
}
#endif
