#ifndef _WINC_UPATOOL
#define _WINC_UPATOOL

#include <WXP/UpaData.h>
#include <WXP/UpaRawinData.h>
#include <WXP/UpaWmoData.h>
#include <WXP/Wind.h>

namespace WXP {
   class UpaTool {
      public:
      static int decode( UpaWmoData &data, UpaRawinData &upadata);
      static int decode( const char *data, UpaRawinData &upadata);
      static int decodeTTAA( UpaWmoData &data, UpaRawinData &upadata);
      static int decodeTTBB( UpaWmoData &data, UpaRawinData &upadata);
      static int decodePPAA( UpaWmoData &data, UpaRawinData &upadata);
      static int decodePPBB( UpaWmoData &data, UpaRawinData &upadata);
      static int merge( UpaRawinData &rawin, UpaData &data );
      static int getStation( const char *filename, const char *id, UpaRawinData &data );
      static int getStation( const char *filename, const char *id, UpaData &data );
      static int printLocate( UpaData &data );
      static int printLevel( UpaLevel &level );
      static int printTable( UpaData &data );
      static int calcStorm( UpaData &data, Wind &storm );
      static int printWindLevel( UpaLevel &level, Wind &storm );
      static int printWind( UpaData &data, Wind &storm );
      static int printStormTable( UpaData &data, Wind &storm );
   };
}
#endif
