#ifndef _WINC_UPAWMOFILE
#define _WINC_UPAWMOFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/Filename.h>
#include <WXP/UpaWmoData.h>

namespace WXP {
   class UpaWmoFile {
      int type;
      int location;
      File file;
      Date date;
      bool opened;
      char line[200];
      char id[10];
      char rep_type[10];	    
      char wmo[21];
      int prtype;
      int prday;
      int prhour;
   
      public:
      UpaWmoFile( );
      UpaWmoFile( const char *filename );
      ~UpaWmoFile( );
      int init();
      bool isOpen();
      int open( const char *filename );
      int open( Filename &filename );
      int rewind( );
      int close( );
      int setDate( Date &rdate );
      int getDate( Date &rdate );
      int read( UpaWmoData &data );
   
      static int checkType( const char *filename );
      /*
         Data types
      */
      enum Type {
         UNK,
         WXP,
         LDM
      };

   };
}   
#endif
