#ifndef _WINC_UPAWXPFILE
#define _WINC_UPAWXPFILE

#include <WXP/Date.h>
#include <WXP/File.h>
#include <WXP/String.h>
#include <WXP/UpaRawinData.h>
      
namespace WXP {
   class UpaWxpFile {
      int type;
      int ver;
      int access;
      long pos;
      int cnt;
      File file;
   
      char date_str[40];
      Date date;
      bool opened;
      
      public:
   
      UpaWxpFile( );
      UpaWxpFile( const char *filename );
      UpaWxpFile( const char *filename, int access );
      ~UpaWxpFile( );
   
      int init();
      int open( const char *filename, int access );
      int getDate( Date &rdate );
      int setDate( Date &rdate );
      inline bool isOpen(){ return opened; };
      int rewind( );
      int close( );
      int read( UpaRawinData &data );
      int readId( String &rid );
      Date getDate();
      const char *getDatestr();
      int write( UpaRawinData &data );
   
      static int checkType( const char *filename );
      static int decodePH( const char *str, float &pres, float &hght );
      static int decodeTD( const char *str, float &temp, float &dewpt );
      static int decodeWD( const char *str, float &dir, float &spd );
      static int encodePH( float pres, float hght, char *str );
      static int encodeTD( float temp, float dewpt, char *str );
      static int encodeWD( float dir, float spd, char *str );
      };
}   
#endif
   
