#ifndef _WINC_VCOORD
#define _WINC_VCOORD

namespace WXP {
   class VCoord {
      int type;
      float val;
      public:

      VCoord();
      VCoord( int rtype, float rval );
      int init();
      int set( int rtype, float rval );
      /** Sets the type of vertical coordinate */
      inline int setType( int rtype ){ type = rtype; return 1; };
      /** Gets the type of vertical coordinate */
      inline int getType(){ return type; };
      /** Sets the value of the vertical coordinate */
      inline int setVal( float rval ){ val = rval; return 1; };
      /** Gets the value of the vertical coordinate */
      inline float getVal(){ return val; };
      int print();

      /** Vertical coordinate types */
      enum Type { 
	 SFC,    /**< Surface level */
	 FREEZE, /**< Freezing level */
	 LCL,    /**< LCL level */
	 MAXWND, /**< Max wind level */
	 TROP,   /**< Tropopause level */
	 PRES,   /**< Pressure level */
	 HEIGHT, /**< Height level */
	 POT     /**< Potential temperature level */
      };
      /** Same as PRES \deprecated */
      static const int PRESS = PRES;

      static bool equal( VCoord a, VCoord b );

      friend class Level;
   };
}
#endif
