#ifndef _WINC_VTEC
#define _WINC_VTEC

#include <WXP/Date.h>

namespace WXP {
   class Vtec {
      int pclass;
      int action;
      char id[5];
      char type[3];
      int sig;
      int num;
      Date bdate;
      Date edate;
   
      public:
      Vtec();
      Vtec( const char *str );
      int init();
      int decode( const char *str );
      int set( const char *str );
      inline int getClass(){ return pclass; };
      inline int getAction(){ return action; };
      inline const char *getId(){ return id; };
      inline const char *getType(){ return type; };
      inline int getSignificance(){ return sig; };
      inline int getNumber(){ return num; };
      inline int getBegDate( Date &rdate ){ rdate = bdate; return 1; };
      inline int getBegSecs(){ return bdate.getSeconds(); };
      inline int getEndDate( Date &rdate ){ rdate = edate; return 1; };
      inline int getEndSecs(){ return edate.getSeconds(); };
      int print();

      enum Class {
	 OPERATIONAL,
	 TEST,
	 EXP_PROD,
	 EXP_VTEC
      };

      enum Action {
	 NEW,
	 CONTINUED,
	 EXTENDED_TIME,
	 EXTENDED_AREA,
	 EXTENDED_BOTH,
	 UPGRADED,
	 CANCELED,
	 EXPIRED,
	 CORRECTION,
	 ROUTINE
      };

      enum Sig {
	 WARNING,
	 WATCH,
	 ADVISORY,
	 STATEMENT,
	 FORECAST,
	 OUTLOOK,
	 SYNOPSIS
      };

      static const char *getClassString( int ind );
      static const char *getActionString( int ind );
      static const char *getPhenomString( const char *type );
      static const char *getSigString( int ind );

   };
}
#endif
