#ifndef _WINC_WMOFILE
#define _WINC_WMOFILE

#include <WXP/File.h>
#include <WXP/Socket.h>
#include <WXP/WmoData.h>

namespace WXP {
   class WmoFile {
      int type;
      Socket sock;
      File file;
      unsigned char buf[1000];
      int bsize;
      int boff;
      static const int buf_len = 1000;
      unsigned char pbuf[5];
      int psize;
      bool opened;

      int prod_size;
      int prod_line;
      int total_prods;
      int total_bytes;

      bool end;
   
      public:
      WmoFile();
      ~WmoFile();
      int init();
      bool isOpen();
      int open( const char *filename );
      int close();
      int read( unsigned char &ch );
      int read( unsigned char *buf, int len );
      int read( WmoData &data );

      inline int getProdLine(){ return prod_line; };
      inline int getProdSize(){ return prod_size; };
      inline int getProdCount(){ return total_prods; };
      inline int getByteCount(){ return total_bytes; };

      enum Type {
         UNK,
	 FILE,
	 SOCKET
      };
   };
}   
#endif
