#ifndef _WINC_WMOINGEST
#define _WINC_WMOINGEST

#include <sys/socket.h>
#include <netinet/in.h>

#include <WXP/Date.h>
#include <WXP/NameConv.h>
#include <WXP/Pan.h>
#include <WXP/Product.h>
#include <WXP/String.h>

namespace WXP {
   class WmoIngest {
      int processing;
      Date fdate;
      Date ctime;
      const static int header_len = 101;
      char header[header_len];
      const static int header2_len = 101;
      char header2[header2_len];

      const static int max_prod = 2000;
      String prod_name;
      Product prod[max_prod];
      int num_prod;

      const static int max_pan = 40;
      Pan pan[max_pan];
      int num_pan;

      int pan_id;

      int binary;
      int raw;

      int seq_test;
      int quit_error;

      String log_name;

      public:
      WmoIngest();
      int init();
      int setParam( const char *str );
      int setProdFile( const char *name );
      int setLogFile( const char *name );
      int setDate( Date &rdate ){ fdate = rdate; return 1; };
      int terminate();
      int printLog( const char *mess, ... );
      int readProdFile( const char *filename );
      int readProdFile();
      int isSelected();
      int cleanLine( char *line, int len, int flag );
      int setAction( const char *command, int offset, char *string, int len );
      int action();
      int close();
      int saveHeader( const char* fullhead, const char *header, 
	    const char *header2 );
      int saveLine( unsigned char *line, int size);
      int sendPAN();
      int process( const char *filename );
      /** Returns if object still processing data */
      inline int checkProcessing(){ return processing; };
   };
}   
#endif
