
/**********************************************************************/
/** \mainpage WXP C++ API Documentation
 *
 * \section intro Introduction
 *
 * The WXP C++ API covers 
 * - Base - basic functions
 * - Utility - utility functions
 * - Data - data containers
 * - Decode - data decoding
 * - IO - data IO
 * - Process - data processing
 * - Plot - data visualization
 *
 * \section install Installation
 *
 * Installation of WXP Library
 */

/**********************************************************************/
/** \defgroup Base Base classes 
 * This defines classes providing simple functionality that all other 
 * classes will use.
 *
 * \defgroup Compute Compute classes 
 * This group contains classes that compute data.
 *
 * \defgroup Data Data classes 
 * This group contains data container classes.
 *
 * \defgroup Decoder Decoder classes 
 * This group contains data decoder classes.
 *
 * \defgroup Device Output device classes 
 * This group contains output devices
 *
 * \defgroup File File IO classes 
 * This group contains file IO utilities for various types of data.
 *
 * \defgroup Plot Plotting classes 
 * This group contains classes that plot data.
 *
 * \defgroup Utility Utility classes 
 * This group contains miscellaneous utility classes.
 */

/**********************************************************************/
/** \namespace WXP
 * \brief All WXP classes fall under the WXP namespace.
 */
