#ifndef _WINC_XSECTIONPLOT
#define _WINC_XSECTIONPLOT

#include <WXP/Drawing.h>
#include <WXP/Plot.h>
#include <WXP/Rect.h>
#include <WXP/Strings.h>

namespace WXP {
   class XSectionPlot : public Drawing {
      Rect view;
      float xmin, xmax, xinc;
      float pmin, pmax, pinc;
      Strings labels;
      float dist[50];

      public:
      XSectionPlot();
      XSectionPlot( const char *str );
      int init();
      int getDomain( Domain &domain );
      int setParam( const char *str );
      int setFile();
      int setInput( const char *str );
      int setNameConv( const char *name );
      int setFilename();
      int setFilename( const char *name );
      int setFilename( Date &date );
      int setFilename( Date &date, const char *param );
      /** Sets forecast time (ignored) */
      inline int setForeTime( const char *fore ){ return 1; };
      int getDate( Date &date );
      int getInitDate( Date &date );
      int getDateOffset();
      int getLoopType();
      int getNumFrames();
      /** Returns whether object is time sync (unused) */
      inline int getSync(){ return 0; };

      int setVertAxis( float rmin, float rmax, float rinc );
      int setHorAxis( float rmin, float rmax );
      int setLabels( Strings &labs );
      int setHorDist( int i, float val );
      float pcoord( float p );
      float getX( float x );
      float getX( int ind );
      float getY( float y );
   
      int draw( Plot &plot );
      int print();
   };
}
#endif
